<script setup lang="ts">
var isSearch = ref(false)

const fixBtn = {
  add: true,
  edit: true,
  delete: true
}

const tableHeaders = reactive([
  { title: '職級別' },
  { title: '職務別' },
  { title: '員工代號' },
  { title: '姓名' },
  { title: '出勤別' },
  { title: '使用者帳號' },
  { title: '使用者密碼' },
  { title: '系統角色' },
  { title: 'Inactive' }
])

const tableData = reactive([
  {
    rank: '第一級',
    position: 'SM',
    employeeID: 'S181101',
    employeeName: '張承翰',
    attendance: '無需要簽到簽退',
    userAccount: 'SysUser001',
    userPassword: 'SysPwd001',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第一級',
    position: 'SM',
    employeeID: 'S181102',
    employeeName: '林淑婷',
    attendance: '無需要簽到簽退',
    userAccount: 'SysUser002',
    userPassword: 'SysPwd002',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第一級',
    position: 'SM',
    employeeID: 'S181103',
    employeeName: '蔡恆善',
    attendance: '無需要簽到簽退',
    userAccount: 'SysUser003',
    userPassword: 'SysPwd003',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第二級',
    position: 'SM',
    employeeID: 'S181104',
    employeeName: '劉逸春',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser004',
    userPassword: 'SysPwd004',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第二級',
    position: 'SM',
    employeeID: 'S181105',
    employeeName: '李珮甄',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser005',
    userPassword: 'SysPwd005',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第二級',
    position: 'SM',
    employeeID: 'S181106',
    employeeName: '洪晴淑',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser006',
    userPassword: 'SysPwd006',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第二級',
    position: 'SM',
    employeeID: 'S181107',
    employeeName: '謝左彥',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser007',
    userPassword: 'SysPwd007',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第二級',
    position: 'SM',
    employeeID: 'S181108',
    employeeName: '吳俊成',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser008',
    userPassword: 'SysPwd008',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第二級',
    position: 'SM',
    employeeID: 'S181109',
    employeeName: '吳佳珠',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser009',
    userPassword: 'SysPwd009',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第三級',
    position: 'SM',
    employeeID: 'S181110',
    employeeName: '王左鳳',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser010',
    userPassword: 'SysPwd010',
    systemRole: 'User',
    inactive: null
  },
  {
    rank: '第三級',
    position: 'SM',
    employeeID: 'S181111',
    employeeName: '許志豪',
    attendance: '需要簽到簽退',
    userAccount: 'SysUser011',
    userPassword: 'SysPwd011',
    systemRole: 'User',
    inactive: null
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const onCreated = (val: any) => {
  console.log('parent add', val)
}

const onEdit = (val: any) => {
  console.log('parent edit', val)
}

const onDelete = (val: any) => {
  console.log('parent delete', val)
}

const turnPage = (val: any) => {
  pageObj.currentPage = val
}

function onSubmit() {
  isSearch.value = true
}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">系統管理</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            系統使用者管理
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">查詢系統使用者</h3>
          <div class="interact-button-list d-flex">
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>新增</p>
              <div class="icon-create"></div>
            </button>
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>匯出 Excel 檔</p>
              <div class="icon-export"></div>
            </button>
          </div>
        </div>
      </div>
    </header>
    <div class="single-operation-board card">
      <h3 class="font-zh-h3 text-color-main">查詢條件</h3>
      <form @submit.prevent="onSubmit">
        <div class="card-body">
          <div class="row">
            <div class="col-12">
              <div class="row align-items-end">
                <p class="font-zh-p-medium">職務別</p>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input id="SM" class="form-check-input" type="checkbox" />
                      <label class="font-zh-p-medium form-check-label" for="SM">
                        SM
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input id="PM" class="form-check-input" type="checkbox" />
                      <label class="font-zh-p-medium form-check-label" for="PM">
                        PM
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="notBusinessEmployee"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="notBusinessEmployee"
                      >
                        非業務員工
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-12">
              <div class="row align-items-end">
                <p class="font-zh-p-medium">職級別</p>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="firstClass"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="firstClass"
                      >
                        第一級
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="secondClass"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="secondClass"
                      >
                        第二級
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="thirdClass"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="thirdClass"
                      >
                        第三級
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-12">
              <div class="row align-items-end">
                <p class="font-zh-p-medium">出勤別</p>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="necessary"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="necessary"
                      >
                        需要簽到簽退
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="unnecessary"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-zh-p-medium form-check-label"
                        for="unnecessary"
                      >
                        無需簽到簽退
                      </label>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-12">
              <div class="row align-items-end">
                <div class="col-3">
                  <p class="font-en-p-medium">Active / Inactive</p>
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="active"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-en-p-medium form-check-label"
                        for="active"
                      >
                        Active
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="input-item">
                    <div class="form-check-item">
                      <input
                        id="inactive"
                        class="form-check-input"
                        type="checkbox"
                      />
                      <label
                        class="font-en-p-medium form-check-label"
                        for="inactive"
                      >
                        Inactive
                      </label>
                    </div>
                  </div>
                </div>
                <div class="col-3">
                  <div class="d-grid gap-2">
                    <button
                      class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                      type="submit"
                    >
                      <p>查詢</p>
                      <div class="icon-search"></div>
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </form>
    </div>
    <div v-show="isSearch">
      <basic-table
        :fix-btn="fixBtn"
        :table-data="showData"
        :table-headers="tableHeaders"
        @add="onCreated"
        @delete="onDelete"
        @edit="onEdit"
      />
      <table-pagination
        :page-obj="pageObj"
        :total-page="totalPage"
        @turn-page="turnPage"
      />
    </div>
  </main>
</template>

<style lang="scss" scoped>
/** style */
</style>
